"use strict";Object.defineProperty(exports, "__esModule", {value: true});



























var _chunkDTYZ2A4Tjs = require('./chunk-DTYZ2A4T.js');


var _chunk5IUQDHHYjs = require('./chunk-5IUQDHHY.js');

// src/index.ts
var _common = require('@vue-macros/common');

// src/vue/analyze.ts








// src/vue/props.ts






// src/vue/types.ts
var DefinitionKind = /* @__PURE__ */ ((DefinitionKind2) => {
  DefinitionKind2["Reference"] = "Reference";
  DefinitionKind2["Object"] = "Object";
  DefinitionKind2["TS"] = "TS";
  return DefinitionKind2;
})(DefinitionKind || {});

// src/vue/utils.ts
var UNKNOWN_TYPE = "Unknown";
async function inferRuntimeType(node) {
  if (_chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, node))
    return ["Object"];
  switch (node.type.type) {
    case "TSStringKeyword":
      return ["String"];
    case "TSNumberKeyword":
      return ["Number"];
    case "TSBooleanKeyword":
      return ["Boolean"];
    case "TSObjectKeyword":
      return ["Object"];
    case "TSTypeLiteral": {
      const types = /* @__PURE__ */ new Set();
      for (const m of node.type.members) {
        switch (m.type) {
          case "TSCallSignatureDeclaration":
          case "TSConstructSignatureDeclaration":
            types.add("Function");
            break;
          default:
            types.add("Object");
        }
      }
      return Array.from(types);
    }
    case "TSFunctionType":
      return ["Function"];
    case "TSArrayType":
    case "TSTupleType":
      return ["Array"];
    case "TSLiteralType":
      switch (node.type.literal.type) {
        case "StringLiteral":
          return ["String"];
        case "BooleanLiteral":
          return ["Boolean"];
        case "NumericLiteral":
        case "BigIntLiteral":
          return ["Number"];
      }
      break;
    case "TSTypeReference":
      if (node.type.typeName.type === "Identifier") {
        switch (node.type.typeName.name) {
          case "Array":
          case "Function":
          case "Object":
          case "Set":
          case "Map":
          case "WeakSet":
          case "WeakMap":
          case "Date":
          case "Promise":
            return [node.type.typeName.name];
          case "Record":
          case "Partial":
          case "Readonly":
          case "Pick":
          case "Omit":
          case "Required":
          case "InstanceType":
            return ["Object"];
          case "Extract":
            if (node.type.typeParameters && node.type.typeParameters.params[1]) {
              const t = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, {
                scope: node.scope,
                type: node.type.typeParameters.params[1]
              });
              if (t)
                return inferRuntimeType(t);
            }
            break;
          case "Exclude":
            if (node.type.typeParameters && node.type.typeParameters.params[0]) {
              const t = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, {
                scope: node.scope,
                type: node.type.typeParameters.params[0]
              });
              if (t)
                return inferRuntimeType(t);
            }
            break;
        }
      }
      break;
    case "TSUnionType": {
      const types = (await Promise.all(
        node.type.types.map(async (subType) => {
          const resolved = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, {
            scope: node.scope,
            type: subType
          });
          return resolved && !_chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, resolved) ? inferRuntimeType(resolved) : void 0;
        })
      )).flatMap((t) => t ? t : ["null"]);
      return [...new Set(types)];
    }
    case "TSIntersectionType":
      return ["Object"];
    case "TSSymbolKeyword":
      return ["Symbol"];
    case "TSInterfaceDeclaration":
      return ["Object"];
  }
  return [UNKNOWN_TYPE];
}
function attachNodeLoc(node, newNode) {
  newNode.start = node.start;
  newNode.end = node.end;
}
function genRuntimePropDefinition(types, isProduction, properties) {
  let type;
  let skipCheck = false;
  if (types) {
    const hasBoolean = types.includes("Boolean");
    const hasUnknown = types.includes(UNKNOWN_TYPE);
    if (hasUnknown)
      types = types.filter((t) => t !== UNKNOWN_TYPE);
    if (isProduction) {
      types = types.filter(
        (t) => t === "Boolean" || hasBoolean && t === "String" || t === "Function"
      );
    } else if (hasUnknown) {
      types = types.filter((t) => t === "Boolean" || t === "Function");
      skipCheck = types.length > 0;
    }
    if (types.length > 0) {
      type = types.length > 1 ? `[${types.join(", ")}]` : types[0];
    }
  }
  const pairs = [];
  if (type)
    pairs.push(`type: ${type}`);
  if (skipCheck)
    pairs.push(`skipCheck: true`);
  pairs.push(...properties);
  return pairs.length > 0 ? `{ ${pairs.join(", ")} }` : "null";
}

// src/vue/props.ts
var builtInTypesHandlers = {
  Partial: {
    handleType(resolved) {
      var _a;
      return (_a = resolved.typeParameters) == null ? void 0 : _a.params[0];
    },
    handleTSProperties(properties) {
      for (const prop of Object.values(properties.properties)) {
        prop.optional = true;
      }
      return properties;
    }
  },
  Required: {
    handleType(resolved) {
      var _a;
      return (_a = resolved.typeParameters) == null ? void 0 : _a.params[0];
    },
    handleTSProperties(properties) {
      for (const prop of Object.values(properties.properties)) {
        prop.optional = false;
      }
      return properties;
    }
  },
  Readonly: {
    handleType(resolved) {
      var _a;
      return (_a = resolved.typeParameters) == null ? void 0 : _a.params[0];
    }
  }
  // TODO: pick, omit
};
async function handleTSPropsDefinition({
  s,
  file,
  offset,
  definePropsAst,
  typeDeclRaw,
  withDefaultsAst,
  defaultsDeclRaw,
  statement,
  declId
}) {
  const { definitions, definitionsAst } = await resolveDefinitions({
    type: typeDeclRaw,
    scope: file
  });
  const { defaults, defaultsAst } = resolveDefaults(defaultsDeclRaw);
  const addProp = (name, value, optional) => {
    const { key, signature, valueAst, signatureAst } = buildNewProp(
      name,
      value,
      optional
    );
    if (definitions[key])
      return false;
    if (definitionsAst.scope === file) {
      if (definitionsAst.ast.type === "TSIntersectionType") {
        s.appendLeft(definitionsAst.ast.end + offset, ` & { ${signature} }`);
      } else {
        s.appendLeft(definitionsAst.ast.end + offset - 1, `  ${signature}
`);
      }
    }
    definitions[key] = {
      type: "property",
      value: {
        code: value,
        ast: valueAst,
        scope: void 0
      },
      optional: !!optional,
      signature: {
        code: signature,
        ast: signatureAst,
        scope: void 0
      },
      addByAPI: true
    };
    return true;
  };
  const setProp = (name, value, optional) => {
    const { key, signature, signatureAst, valueAst } = buildNewProp(
      name,
      value,
      optional
    );
    const def = definitions[key];
    if (!definitions[key])
      return false;
    switch (def.type) {
      case "method": {
        attachNodeLoc(def.methods[0].ast, signatureAst);
        if (def.methods[0].scope === file)
          s.overwriteNode(def.methods[0].ast, signature, { offset });
        def.methods.slice(1).forEach((method) => {
          if (method.scope === file) {
            s.removeNode(method.ast, { offset });
          }
        });
        break;
      }
      case "property": {
        attachNodeLoc(def.signature.ast, signatureAst);
        if (def.signature.scope === file && !def.addByAPI) {
          s.overwriteNode(def.signature.ast, signature, { offset });
        }
        break;
      }
    }
    definitions[key] = {
      type: "property",
      value: {
        code: value,
        ast: valueAst,
        scope: void 0
      },
      optional: !!optional,
      signature: {
        code: signature,
        ast: signatureAst,
        scope: void 0
      },
      addByAPI: def.type === "property" && def.addByAPI
    };
    return true;
  };
  const removeProp = (name) => {
    const key = _chunk5IUQDHHYjs.keyToString.call(void 0, name);
    if (!definitions[key])
      return false;
    const def = definitions[key];
    switch (def.type) {
      case "property": {
        if (def.signature.scope === file && !def.addByAPI) {
          s.removeNode(def.signature.ast, { offset });
        }
        break;
      }
      case "method":
        def.methods.forEach((method) => {
          if (method.scope === file)
            s.removeNode(method.ast, { offset });
        });
        break;
    }
    delete definitions[key];
    return true;
  };
  const getRuntimeDefinitions = async () => {
    const props = {};
    for (const [propName, def] of Object.entries(definitions)) {
      let prop;
      if (def.type === "method") {
        prop = {
          type: ["Function"],
          required: !def.optional
        };
      } else {
        const resolvedType = def.value;
        if (resolvedType) {
          const optional = def.optional;
          prop = {
            type: await inferRuntimeType({
              scope: resolvedType.scope || file,
              type: resolvedType.ast
            }),
            required: !optional
          };
        } else {
          prop = { type: ["null"], required: false };
        }
      }
      const defaultValue = defaults == null ? void 0 : defaults[propName];
      if (defaultValue) {
        prop.default = (key = "default") => {
          switch (defaultValue.type) {
            case "ObjectMethod":
              return `${defaultValue.kind !== "method" ? `${defaultValue.kind} ` : ""}${defaultValue.async ? `async ` : ""}${key}(${s.sliceNode(
                defaultValue.params,
                { offset }
              )}) ${s.sliceNode(defaultValue.body, { offset })}`;
            case "ObjectProperty":
              return `${key}: ${s.sliceNode(defaultValue.value, { offset })}`;
          }
        };
      }
      props[propName] = prop;
    }
    return props;
  };
  return {
    kind: "TS" /* TS */,
    definitions,
    defaults,
    declId,
    addProp,
    setProp,
    removeProp,
    getRuntimeDefinitions,
    // AST
    definitionsAst,
    defaultsAst,
    statementAst: statement,
    definePropsAst,
    withDefaultsAst
  };
  async function resolveUnion(definitionsAst2, scope) {
    const unionDefs = [];
    const keys = /* @__PURE__ */ new Set();
    for (const type of definitionsAst2.types) {
      const defs = await resolveDefinitions({ type, scope }).then(
        ({ definitions: definitions2 }) => definitions2
      );
      Object.keys(defs).map((key) => keys.add(key));
      unionDefs.push(defs);
    }
    const results = {};
    for (const key of keys) {
      let optional = false;
      let result;
      for (const defMap of unionDefs) {
        const def = defMap[key];
        if (!def) {
          optional = true;
          continue;
        }
        optional || (optional = def.optional);
        if (!result) {
          result = def;
          continue;
        }
        if (result.type === "method" && def.type === "method") {
          result.methods.push(...def.methods);
        } else if (result.type === "property" && def.type === "property") {
          if (!def.value) {
            continue;
          } else if (!result.value) {
            result = def;
            continue;
          }
          if (def.value.ast.type === "TSImportType" || def.value.ast.type === "TSDeclareFunction" || def.value.ast.type === "TSEnumDeclaration" || def.value.ast.type === "TSInterfaceDeclaration" || def.value.ast.type === "TSModuleDeclaration" || result.value.ast.type === "TSImportType" || result.value.ast.type === "TSDeclareFunction" || result.value.ast.type === "TSEnumDeclaration" || result.value.ast.type === "TSInterfaceDeclaration" || result.value.ast.type === "TSModuleDeclaration") {
            continue;
          }
          if (result.value.ast.type === "TSUnionType") {
            result.value.ast.types.push(def.value.ast);
          } else {
            result = {
              type: "property",
              value: buildDefinition({
                scope,
                type: {
                  type: "TSUnionType",
                  types: [result.value.ast, def.value.ast]
                }
              }),
              signature: null,
              optional,
              addByAPI: false
            };
          }
        } else {
          throw new SyntaxError(
            `Cannot resolve TS definition. Union type contains different types of results.`
          );
        }
      }
      if (result) {
        results[key] = { ...result, optional };
      }
    }
    return {
      definitions: results,
      definitionsAst: buildDefinition({ scope, type: definitionsAst2 })
    };
  }
  async function resolveIntersection(definitionsAst2, scope) {
    const results = {};
    for (const type of definitionsAst2.types) {
      const defMap = await resolveDefinitions({ type, scope }).then(
        ({ definitions: definitions2 }) => definitions2
      );
      for (const [key, def] of Object.entries(defMap)) {
        const result = results[key];
        if (!result) {
          results[key] = def;
          continue;
        }
        if (result.type === "method" && def.type === "method") {
          result.methods.push(...def.methods);
        } else {
          results[key] = def;
        }
      }
    }
    return {
      definitions: results,
      definitionsAst: buildDefinition({ scope, type: definitionsAst2 })
    };
  }
  async function resolveNormal(properties) {
    const definitions2 = {};
    for (const [key, sign] of Object.entries(properties.methods)) {
      const methods = sign.map((sign2) => buildDefinition(sign2));
      definitions2[key] = {
        type: "method",
        methods,
        optional: sign.some((sign2) => !!sign2.type.optional)
      };
    }
    for (const [key, value] of Object.entries(properties.properties)) {
      const referenced = value.value ? await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, value.value) : void 0;
      definitions2[key] = {
        type: "property",
        addByAPI: false,
        value: referenced && !_chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, referenced) ? buildDefinition(referenced) : void 0,
        optional: value.optional,
        signature: buildDefinition(value.signature)
      };
    }
    return definitions2;
  }
  async function resolveDefinitions(typeDeclRaw2) {
    let resolved = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, typeDeclRaw2) || typeDeclRaw2;
    let builtInTypesHandler;
    if (resolved && !_chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, resolved) && resolved.type.type === "TSTypeReference" && resolved.type.typeName.type === "Identifier") {
      const typeName = resolved.type.typeName.name;
      let type;
      if (typeName in builtInTypesHandlers) {
        builtInTypesHandler = builtInTypesHandlers[typeName];
        type = builtInTypesHandler.handleType(resolved.type);
      }
      if (type)
        resolved = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, {
          type,
          scope: resolved.scope
        });
    }
    if (!resolved || _chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, resolved)) {
      throw new SyntaxError(`Cannot resolve TS definition.`);
    }
    const { type: definitionsAst2, scope } = resolved;
    if (definitionsAst2.type === "TSIntersectionType") {
      return resolveIntersection(definitionsAst2, scope);
    } else if (definitionsAst2.type === "TSUnionType") {
      return resolveUnion(definitionsAst2, scope);
    } else if (definitionsAst2.type !== "TSInterfaceDeclaration" && definitionsAst2.type !== "TSTypeLiteral" && definitionsAst2.type !== "TSMappedType")
      throw new SyntaxError(
        `Cannot resolve TS definition: ${definitionsAst2.type}.`
      );
    let properties = await _chunkDTYZ2A4Tjs.resolveTSProperties.call(void 0, {
      scope,
      type: definitionsAst2
    });
    if (builtInTypesHandler == null ? void 0 : builtInTypesHandler.handleTSProperties)
      properties = builtInTypesHandler.handleTSProperties(properties);
    return {
      definitions: await resolveNormal(properties),
      definitionsAst: buildDefinition({ scope, type: definitionsAst2 })
    };
  }
  function resolveDefaults(defaultsAst2) {
    if (!defaultsAst2)
      return {};
    const isStatic = defaultsAst2.type === "ObjectExpression" && _common.isStaticObjectKey.call(void 0, defaultsAst2);
    if (!isStatic)
      return { defaultsAst: defaultsAst2 };
    const defaults2 = _common.resolveObjectExpression.call(void 0, defaultsAst2);
    if (!defaults2)
      return { defaultsAst: defaultsAst2 };
    return { defaults: defaults2, defaultsAst: defaultsAst2 };
  }
  function buildNewProp(name, value, optional) {
    const key = _chunk5IUQDHHYjs.keyToString.call(void 0, name);
    const signature = `${name}${optional ? "?" : ""}: ${value}`;
    const valueAst = _common.babelParse.call(void 0, `type T = (${value})`, "ts").body[0].typeAnnotation.typeAnnotation;
    const signatureAst = _common.babelParse.call(void 0, `interface T {${signature}}`, "ts").body[0].body.body[0];
    return { key, signature, signatureAst, valueAst };
  }
  function buildDefinition({
    type,
    scope
  }) {
    return {
      code: _chunkDTYZ2A4Tjs.resolveTSScope.call(void 0, scope).file.content.slice(type.start, type.end),
      ast: type,
      scope
    };
  }
}

// src/vue/emits.ts





async function handleTSEmitsDefinition({
  s,
  file,
  offset,
  defineEmitsAst,
  typeDeclRaw,
  declId,
  statement
}) {
  const { definitions, definitionsAst } = await resolveDefinitions({
    type: typeDeclRaw,
    scope: file
  });
  const addEmit = (name, signature) => {
    const key = _chunk5IUQDHHYjs.keyToString.call(void 0, name);
    if (definitionsAst.scope === file) {
      if (definitionsAst.ast.type === "TSIntersectionType") {
        s.appendLeft(definitionsAst.ast.end + offset, ` & { ${signature} }`);
      } else {
        s.appendLeft(definitionsAst.ast.end + offset - 1, `  ${signature}
`);
      }
    }
    if (!definitions[key])
      definitions[key] = [];
    const ast = parseSignature(signature);
    definitions[key].push({
      code: signature,
      ast,
      scope: void 0
    });
  };
  const setEmit = (name, idx, signature) => {
    const key = _chunk5IUQDHHYjs.keyToString.call(void 0, name);
    const def = definitions[key][idx];
    if (!def)
      return false;
    const ast = parseSignature(signature);
    attachNodeLoc(def.ast, ast);
    if (def.scope === file)
      s.overwriteNode(def.ast, signature, { offset });
    definitions[key][idx] = {
      code: signature,
      ast,
      scope: void 0
    };
    return true;
  };
  const removeEmit = (name, idx) => {
    const key = _chunk5IUQDHHYjs.keyToString.call(void 0, name);
    const def = definitions[key][idx];
    if (!def)
      return false;
    if (def.scope === file)
      s.removeNode(def.ast, { offset });
    delete definitions[key][idx];
    return true;
  };
  return {
    kind: "TS" /* TS */,
    definitions,
    definitionsAst,
    declId,
    addEmit,
    setEmit,
    removeEmit,
    statementAst: statement,
    defineEmitsAst
  };
  function parseSignature(signature) {
    return _common.babelParse.call(void 0, `interface T {${signature}}`, "ts").body[0].body.body[0];
  }
  async function resolveDefinitions(typeDeclRaw2) {
    var _a;
    const resolved = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, typeDeclRaw2);
    if (!resolved || _chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, resolved))
      throw new SyntaxError(`Cannot resolve TS definition.`);
    const { type: definitionsAst2, scope } = resolved;
    if (definitionsAst2.type !== "TSInterfaceDeclaration" && definitionsAst2.type !== "TSTypeLiteral" && definitionsAst2.type !== "TSIntersectionType" && definitionsAst2.type !== "TSFunctionType")
      throw new SyntaxError(
        `Cannot resolve TS definition: ${definitionsAst2.type}`
      );
    const properties = await _chunkDTYZ2A4Tjs.resolveTSProperties.call(void 0, {
      scope,
      type: definitionsAst2
    });
    const definitions2 = {};
    for (const signature of properties.callSignatures) {
      const evtArg = signature.type.parameters[0];
      if (!evtArg || evtArg.type !== "Identifier" || ((_a = evtArg.typeAnnotation) == null ? void 0 : _a.type) !== "TSTypeAnnotation")
        continue;
      const evtType = await _chunkDTYZ2A4Tjs.resolveTSReferencedType.call(void 0, {
        type: evtArg.typeAnnotation.typeAnnotation,
        scope: signature.scope
      });
      if (_chunkDTYZ2A4Tjs.isTSNamespace.call(void 0, evtType) || !(evtType == null ? void 0 : evtType.type))
        continue;
      const types = evtType.type.type === "TSUnionType" ? evtType.type.types : [evtType.type];
      for (const type of types) {
        if (type.type !== "TSLiteralType")
          continue;
        const literal = type.literal;
        if (!_common.isStaticExpression.call(void 0, literal))
          continue;
        const evt = String(
          _common.resolveLiteral.call(void 0, literal)
        );
        if (!definitions2[evt])
          definitions2[evt] = [];
        definitions2[evt].push(buildDefinition(signature));
      }
    }
    return {
      definitions: definitions2,
      definitionsAst: buildDefinition({ scope, type: definitionsAst2 })
    };
  }
  function buildDefinition({
    type,
    scope
  }) {
    return {
      code: _chunkDTYZ2A4Tjs.resolveTSScope.call(void 0, scope).file.content.slice(type.start, type.end),
      ast: type,
      scope
    };
  }
}

// src/vue/analyze.ts

async function analyzeSFC(s, sfc) {
  if (!sfc.scriptSetup)
    throw new Error("Only <script setup> is supported");
  const { scriptSetup } = sfc;
  const body = _common.babelParse.call(void 0, 
    scriptSetup.content,
    sfc.scriptSetup.lang || "js"
  ).body;
  const offset = scriptSetup.loc.start.offset;
  const file = {
    kind: "file",
    filePath: sfc.filename,
    content: scriptSetup.content,
    ast: body
  };
  let props;
  let emits;
  for (const node of body) {
    if (node.type === "ExpressionStatement") {
      await processDefineProps({
        statement: node,
        defineProps: node.expression
      });
      await processWithDefaults({
        statement: node,
        withDefaults: node.expression
      });
      await processDefineEmits({
        statement: node,
        defineEmits: node.expression
      });
    } else if (node.type === "VariableDeclaration" && !node.declare) {
      for (const decl of node.declarations) {
        if (!decl.init)
          continue;
        await processDefineProps({
          statement: node,
          defineProps: decl.init,
          declId: decl.id
        });
        await processWithDefaults({
          statement: node,
          withDefaults: decl.init,
          declId: decl.id
        });
        await processDefineEmits({
          statement: node,
          defineEmits: decl.init,
          declId: decl.id
        });
      }
    }
  }
  return {
    props,
    emits
  };
  async function processDefineProps({
    defineProps,
    declId,
    statement,
    withDefaultsAst,
    defaultsDeclRaw
  }) {
    var _a;
    if (!_common.isCallOf.call(void 0, defineProps, _common.DEFINE_PROPS) || props)
      return false;
    const typeDeclRaw = (_a = defineProps.typeParameters) == null ? void 0 : _a.params[0];
    if (typeDeclRaw) {
      props = await handleTSPropsDefinition({
        s,
        file,
        sfc,
        offset,
        definePropsAst: defineProps,
        typeDeclRaw,
        withDefaultsAst,
        defaultsDeclRaw,
        statement,
        declId
      });
    } else {
      return false;
    }
    return true;
  }
  async function processWithDefaults({
    withDefaults,
    declId,
    statement: stmt
  }) {
    if (!_common.isCallOf.call(void 0, withDefaults, _common.WITH_DEFAULTS))
      return false;
    if (!_common.isCallOf.call(void 0, withDefaults.arguments[0], _common.DEFINE_PROPS)) {
      throw new SyntaxError(
        `${_common.WITH_DEFAULTS}: first argument must be a ${_common.DEFINE_PROPS} call.`
      );
    }
    const isDefineProps = await processDefineProps({
      defineProps: withDefaults.arguments[0],
      declId,
      statement: stmt,
      withDefaultsAst: withDefaults,
      defaultsDeclRaw: withDefaults.arguments[1]
    });
    if (!isDefineProps)
      return false;
    return true;
  }
  async function processDefineEmits({
    defineEmits,
    declId,
    statement
  }) {
    var _a;
    if (!_common.isCallOf.call(void 0, defineEmits, _common.DEFINE_EMITS) || emits)
      return false;
    const typeDeclRaw = (_a = defineEmits.typeParameters) == null ? void 0 : _a.params[0];
    if (typeDeclRaw) {
      emits = await handleTSEmitsDefinition({
        s,
        file,
        sfc,
        offset,
        defineEmitsAst: defineEmits,
        typeDeclRaw,
        statement,
        declId
      });
    } else {
      return false;
    }
    return true;
  }
}







































exports.DefinitionKind = DefinitionKind; exports.MagicString = _common.MagicString; exports.RollupResolve = _chunkDTYZ2A4Tjs.RollupResolve; exports.UNKNOWN_TYPE = UNKNOWN_TYPE; exports.analyzeSFC = analyzeSFC; exports.attachNodeLoc = attachNodeLoc; exports.checkForTSProperties = _chunkDTYZ2A4Tjs.checkForTSProperties; exports.createStringLiteral = _chunkDTYZ2A4Tjs.createStringLiteral; exports.createTSLiteralType = _chunkDTYZ2A4Tjs.createTSLiteralType; exports.createUnionType = _chunkDTYZ2A4Tjs.createUnionType; exports.genRuntimePropDefinition = genRuntimePropDefinition; exports.getTSFile = _chunkDTYZ2A4Tjs.getTSFile; exports.getTSPropertiesKeys = _chunkDTYZ2A4Tjs.getTSPropertiesKeys; exports.handleTSEmitsDefinition = handleTSEmitsDefinition; exports.handleTSPropsDefinition = handleTSPropsDefinition; exports.inferRuntimeType = inferRuntimeType; exports.isSupportedForTSReferencedType = _chunkDTYZ2A4Tjs.isSupportedForTSReferencedType; exports.isTSDeclaration = _chunkDTYZ2A4Tjs.isTSDeclaration; exports.isTSNamespace = _chunkDTYZ2A4Tjs.isTSNamespace; exports.keyToString = _chunk5IUQDHHYjs.keyToString; exports.mergeTSProperties = _chunkDTYZ2A4Tjs.mergeTSProperties; exports.namespaceSymbol = _chunkDTYZ2A4Tjs.namespaceSymbol; exports.parseSFC = _common.parseSFC; exports.resolveMaybeTSUnion = _chunkDTYZ2A4Tjs.resolveMaybeTSUnion; exports.resolveReferenceName = _chunkDTYZ2A4Tjs.resolveReferenceName; exports.resolveTSFileId = _chunkDTYZ2A4Tjs.resolveTSFileId; exports.resolveTSFileIdNode = _chunkDTYZ2A4Tjs.resolveTSFileIdNode; exports.resolveTSIndexedAccessType = _chunkDTYZ2A4Tjs.resolveTSIndexedAccessType; exports.resolveTSLiteralType = _chunkDTYZ2A4Tjs.resolveTSLiteralType; exports.resolveTSNamespace = _chunkDTYZ2A4Tjs.resolveTSNamespace; exports.resolveTSProperties = _chunkDTYZ2A4Tjs.resolveTSProperties; exports.resolveTSReferencedType = _chunkDTYZ2A4Tjs.resolveTSReferencedType; exports.resolveTSScope = _chunkDTYZ2A4Tjs.resolveTSScope; exports.resolveTSTemplateLiteral = _chunkDTYZ2A4Tjs.resolveTSTemplateLiteral; exports.resolveTSTypeOperator = _chunkDTYZ2A4Tjs.resolveTSTypeOperator; exports.resolveTypeElements = _chunkDTYZ2A4Tjs.resolveTypeElements; exports.setResolveTSFileIdImpl = _chunkDTYZ2A4Tjs.setResolveTSFileIdImpl; exports.tsFileCache = _chunkDTYZ2A4Tjs.tsFileCache;
